﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 가상 리스트 박스를 설정한다.

            this.virtualListBox.BackColor = Color.White;

            this.virtualListBox.LastRenderTimeChanged += (s, e) => this.timeLabel.Invoke
            (
                (MethodInvoker)delegate {
                
                    this.timeLabel.Text = "렌더링 시간 : " + this.virtualListBox.LastRenderTime + "밀리초";
                }
            );

            this.virtualListBox.BeginUpdate();

            for(int i = 0; 1000000 > i; i++)
            {
                this.virtualListBox.ItemCollection.Add(string.Format("가상 리스트 박스 항목 {0}", i + 1));
            }

            this.virtualListBox.EndUpdate();

            #endregion

            this.addButton.Click                      += addButton_Click;
            this.itemHeightNumericUpDown.ValueChanged += itemHeightNumericUpDown_ValueChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 추가 버튼 클릭시 처리하기 - addButton_Click(sender, e)

        /// <summary>
        /// 추가 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void addButton_Click(object sender, EventArgs e)
        {
            Random random = new Random();

            this.virtualListBox.BeginUpdate();
            
            for(int i = 0; 100000 > i; i++)
            {
                this.virtualListBox.ItemCollection.Add(string.Format("추가 가상 리스트 박스 항목 {0}", random.Next(10000000, 99999999)));
            }

            this.virtualListBox.EndUpdate();
        }

        #endregion
        #region 항목 높이 숫자 UP/DOWN 값 변경시 처리하기 - itemHeightNumericUpDown_ValueChanged(sender, e)

        /// <summary>
        /// 항목 높이 숫자 UP/DOWN 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void itemHeightNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            this.virtualListBox.ItemHeight = (int)this.itemHeightNumericUpDown.Value;
        }

        #endregion
    }
}